<?php
class Polymorphic extends CakeMigration {

/**
 * Migration description
 *
 * @var string
 */
	public $description = 'polymorphic';

/**
 * Actions to be performed
 *
 * @var array $migration
 */
	public $migration = array(
		'up' => array(
			'create_field' => array(
				'ev_facebook_facebook_connections' => array(
					'model' => array('type' => 'string', 'null' => false, 'default' => null, 'collate' => 'utf8_general_ci', 'charset' => 'utf8', 'after' => 'id'),
					'model_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'after' => 'model'),
					'facebook_page_id' => array('type' => 'string', 'null' => true, 'default' => null, 'length' => 32, 'collate' => 'utf8_general_ci', 'charset' => 'utf8', 'after' => 'model_id'),
				),
				'ev_facebook_facebook_streams' => array(
					'facebook_connection_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'after' => 'id'),
				),
			),
		),
		'down' => array(
			'drop_field' => array(
				'ev_facebook_facebook_connections' => array('model', 'model_id', 'facebook_page_id'),
				'ev_facebook_facebook_streams' => array('facebook_connection_id'),
			),
		),
	);

/**
 * Before migration callback
 *
 * @param string $direction Direction of migration process (up or down)
 * @return boolean Should process continue
 */
	public function before($direction) {
		return true;
	}

/**
 * After migration callback
 *
 * @param string $direction Direction of migration process (up or down)
 * @return boolean Should process continue
 */
	public function after($direction) {
		return true;
	}
}
