<?php

App::uses('EvFacebookAppModel', 'EvFacebook.Model');
App::uses('FacebookConnection', 'EvFacebook.Model');
App::uses('CakeTime', 'Utility');

class FacebookStream extends EvFacebookAppModel {

	public function __construct($id = false, $table = null, $ds = null) {

		parent::__construct($id, $table, $ds);

		$this->FacebookConnection = ClassRegistry::init('EvFacebook.FacebookConnection');
	}

	public function getStream($limit=10, $conditions=array()) {
		
		$connection = $this->FacebookConnection->find('first', $conditions);
		
		if($connection['FacebookConnection']['facebook_page_id'] != '') {
			$facebookPageId = $connection['FacebookConnection']['facebook_page_id'];
		}
		else {
			$facebookPageId = Configure::read('Facebook.page_id');
		}

		// If we haven't updated the cached stream for 5 hours get the latest posts
		if (empty($connection['FacebookConnection']['last_checked']) || !CakeTime::wasWithinLast('5 hours', $connection['FacebookConnection']['last_checked'])) {

			if (!empty($lastInsert)) {
				$lastFbPostDate = $this->field('post_date', array(), 'post_date DESC');
				$dateFql = ' AND created_time > ' . strtotime($lastFbPostDate);
			} else {
				$dateFql = '';
			}

			$fql = 'SELECT permalink, created_time, attachment, message FROM stream';
			$fql .= ' WHERE source_id=' . $facebookPageId . ' AND actor_id=' . $facebookPageId;
			$fql .= ' AND message <> \'\'';
			$fql .= $dateFql;
			$fql .= ' LIMIT ' . $limit;
			//$response = $this->Facebook->api('/me');
			$response = $this->Facebook->api(array(
				'method' => 'fql.query',
				'query' => $fql
			));
			//print_r($response);die();
			$data = array();

			foreach ($response as $row) {

				$data[] = array(
					'facebook_connection_id' => $connection['FacebookConnection']['id'],
					'post' => serialize($row),
					'post_date' => CakeTime::format('Y-m-d H:i:s', $row['created_time'])
				);

			}

			$this->saveMany($data);

			if (!empty($connection['FacebookConnection']['id'])) {
				$this->FacebookConnection->id = $connection['FacebookConnection']['id'];
			}
			$this->FacebookConnection->saveField('last_checked', gmdate('Y-m-d H:i:s'));

		}

		$data = $this->find('all', array(
			'conditions' => array('facebook_connection_id' => $connection['FacebookConnection']['id']),
			'fields' => array(
				$this->escapeField(),
				$this->escapeField('post'),
				$this->escapeField('post_date')
			),
			'order' => array(
				$this->escapeField('post_date') => 'DESC'
			),
			'limit' => $limit
		));

		return $data;

	}


	public function afterFind($results, $primary = false) {

		$results = parent::afterFind($results, $primary);

		foreach ($results as &$row) {
			if (isset($row[$this->alias]['post'])) {
				$row[$this->alias]['post'] = unserialize($row[$this->alias]['post']);
			}
		}

		return $results;

	}

}